---
title: Clipboard.write()
slug: Web/API/Clipboard/write
tags:
  - API
  - Clip
  - Clipboard
  - Clipboard API
  - Cut
  - Method
  - Pasteboard
  - Reference
  - Scrap
  - copy
  - paste
  - write
---
<div>{{APIRef("Clipboard API")}}</div>

<p><span class="seoSummary">The {{domxref("Clipboard")}} method <strong><code>write()</code></strong> writes arbitrary data, such as images, to the clipboard.</span> This can be used to implement cut and copy functionality.</p>

<p>The <code>"clipboard-write"</code> permission of the <a href="/en-US/docs/Web/API/Permissions_API">Permissions API</a>, is granted automatically to pages when they are in the active tab.</p>

<div class="note">
<p><strong>Note:</strong> Browser support for the asynchronous clipboard APIs is still in the process of being implemented. Be sure to check the {{anch("Browser compatibility", "compatibility table")}} as well as {{SectionOnPage("/en-US/docs/Web/API/Clipboard", "Clipboard availability")}} for more information.</p>
</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate">var <em>promise</em> = navigator.clipboard.write(<em>data</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>data</code></dt>
 <dd>An array of {{domxref("ClipboardItem")}} objects containing data to be written to the clipboard.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} which is resolved when the data has been written to the clipboard. The promise is rejected if the clipboard is unable to complete the clipboard access.</p>

<h2 id="Example">Example</h2>

<p>This example function replaces the current contents of the clipboard with a specified string.</p>

<pre class="brush: js notranslate">function setClipboard(text) {
  let data = [new ClipboardItem({ "text/plain": text })];

  navigator.clipboard.write(data).then(function() {
    /* success */
  }, function() {
    /* failure */
  });
}
</pre>

<p>The code begins by creating a new {{domxref("ClipboardItem")}} object into which the text will be placed for sending to the clipboard. The key of the object passed to the {{domxref("ClipboardItem")}} constructor indicates the content type, the value indicates the content. The content could be a text or even a Blob (e.g. for copying images to the clipboard). Then <code>write()</code> is called, specifying both a fulfilment function and an error function.</p>

<h3 id="Example_of_copying_canvas_contents_to_the_clipboard">Example of copying canvas contents to the clipboard</h3>

<pre class="brush: js notranslate">function copyCanvasContentsToClipboard(canvas, onDone, onError) {
  canvas.toBlob(function (blob) {
    let data = [new ClipboardItem({ [blob.type]: blob })];

    navigator.clipboard.write(data).then(function () {
      onDone();
    }, function (err) {
      onError(err);
    })
  });
}</pre>

<div class="note">
<p><strong>Note</strong>: You can only pass in one clipboard item at a time.</p>
</div>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Clipboard API','#dom-clipboard-write','write()')}}</td>
   <td>{{Spec2('Clipboard API')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Clipboard.write")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/Clipboard_API">Clipboard API</a></li>
 <li><a href="https://async-clipboard-api.glitch.me/">Async Clipboard API demo on Glitch</a></li>
 <li><a href="https://web.dev/image-support-for-async-clipboard/">Image support for Async Clipboard article</a></li>
</ul>
